library WsDLL;

{  A causa dell'errore 48 del turbo pascal 1.5, il file
   WSDLL.PAS e' stato suddiviso in due files: WSDLL1.PAS
   e WSDLL.PAS.
   TUTTI I COMMENTI UTILI SONO CONTENUTI IN WSDLL1.PAS
}
{  Questa libreria contiene le funzioni e procedure per
   la gestione degli oggetti che possono essere usati
   per costruire un sistema in ambiente WinSound.
   La libreria e' espandibile indipendentemente da WinSound.
   Libreria usata da WS,WSWND e WSOBJ.

   Il file WSDLL.RES e' stato suddiviso nei files WSDLL.RES e
   WSDLL1.RES a causa dell'errore 45 del turbo pascal 1.5

   Ver 0.5   07-03-97: Rimossi gli elementi Borland dalle risorse
}

{$R WSDLL}     { WSDLL=resource name }
{$R WSDLL1}    { WSDLL1=resource name }

uses WinTypes, WinProcs, WObjects, WSObj, Strings,
     CommDlg, WSDLL1, WinDos, WSMCI, MMSystem;
type
      PMacro=^TMacro;
      TMacro=object(TBlock)
                startp:pObj;
                LoadResult:integer;
                pSys:pSystem;
                fn:TFileName;
                constructor Init(SystemP:pSystem;Num:integer;HWindow:HWnd);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function ProcessDlg(HWindow:HWnd;wParam:word):integer;virtual;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                procedure Stop;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                function ReadSystem(tfn:TFilename):boolean;
                destructor Done;virtual;
                end;
      PRecord=^TRecord;
      TRecord=object(TBlock)
                f:integer;TempFile:TFileName;
                fsample,slength,residual:longint;
                MemHandle:THandle;MemPtr:pointer;
                ParentWnd:HWnd;
                function Check(var prop:AIOprop):integer;virtual;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                procedure Stop;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;
      PSwitch=^TSwitch;
      TSwitch=object(TBlock)
                ControlType,SwitchType:integer;
                control:integer;
                MemHandle:THandle;MemPtr:pointer;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                procedure Stop;virtual;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;
      PRxy=^TRxy;
      TRxy=object(TBlock)
                RxyType,InputType:integer;
                cumulative,biased:integer;
                M:integer;
                OldN:longint;
                MemHandle:THandle;MemPtr:pointer;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                procedure Stop;virtual;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;
      PTextOut=^TTextOut;
      TTextOut=object(TBlock)
                f:text;
                fn:TFileName;
                owntype,control:integer;
                slength:longint;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function ProcessDlg(HWindow:HWnd;wParam:word):integer;virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                procedure Stop;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                end;
      PFastMod=^TFastMod;
      TFastMod=object(TBlock)
                InputType:integer;
                MemHandle:THandle;MemPtr:pointer;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                procedure Stop;virtual;
                end;
      PFFTR=^TFFTR;
      TFFTR=object(TBlock)
                InputType:integer;
                window:integer;
                M:integer;
                reH:THandle;rePtr:pointer;
                imH:THandle;imPtr:pointer;
                winH:THandle;winPtr:pointer; (* window *)
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                procedure Stop;virtual;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;
      PIFFTR=^TIFFTR;
      TIFFTR=object(TBlock)
                InputType:integer;
                M:integer;
                reH:THandle;rePtr:pointer;
                imH:THandle;imPtr:pointer;
                procedure Capability(var Attr:TAttrDev;var IOClass:TAIOClass);virtual;
                function Check(var prop:AIOprop):integer;virtual;
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                procedure Stop;virtual;
                constructor Init(SystemP:pSystem;Num:integer);
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;
      PMediaSeq=^TMediaSeq;
      TMediaSeq=object(T1In1Out)
                nsub,M:integer;
                constructor Init(SystemP:pSystem;Num:integer);
                function Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;virtual;
                procedure SetDlg(HWindow:HWnd);virtual;
                procedure GetDlg(HWindow:HWnd;var st:string);virtual;
                function Transfer(var iop:aiobuf):integer;virtual;
                function StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;virtual;
                end;

procedure SetUpPalette;
var
  i: Integer;

  procedure SetPalette(i:integer;r,g,b:byte);
  begin
      ImageLogPalette^.palPalEntry[i].peRed := r;
      ImageLogPalette^.palPalEntry[i].peGreen := g;
      ImageLogPalette^.palPalEntry[i].peBlue := b;
      ImageLogPalette^.palPalEntry[i].peFlags := pc_NoCollapse;
  end;

begin
  GetMem(ImageLogPalette, SizeOf(TLogPalette) + SizeOf(TPaletteEntry) * 128);
  ImageLogPalette^.palVersion := $300;
  ImageLogPalette^.palNumEntries := 128;
  for i:=0 to 31
  do SetPalette(i,i*4,32,32+i*7);
  for i:=32 to 63
  do SetPalette(i,i*4,32,479-i*7);
  for i:=0 to 31
  do SetPalette(64+i,255,i*8,64);
  for i:=0 to 31
  do SetPalette(96+i,255,255,i*8);
  ThePalette := CreatePalette(ImageLogPalette^);
end;

procedure DLLExit;far;
var i:integer;
begin
  ExitProc:=OldProc;
  FreeProcInstance(Display1Proc);
  DeleteObject(ThePalette);
(*  AP7: rilasciare la memoria impegnata per i colori
  FreeMem(ImageLogPalette, sizeof(TLogPalette) + sizeof(TPaletteEntry) * 128);*)
  for i:=0 to zLast
  do DeleteObject(BitMap[i]);
end;

const Objectp:PBlock=nil; (* Usato da WSDLLDlg *)

function WSDLLDlg(HWindow: HWnd; Message: Word; wParam: Word;
  lParam: Longint): Longint; export;
var
  testo:array[0..31]of char;
  s:string[31];
begin
  case Message of
    wm_InitDialog:
      begin
       Objectp:=pBlock(LParam);
       Objectp^.SetDlg(HWindow);
      end;
    wm_Command:
      case wParam of
	idCancel:
	  EndDialog(HWindow, 0);
	idOk:
	  begin
            if Objectp^.GetDlgOk(HWindow)
            then EndDialog(HWindow, 1)
	  end;
        100..199:if Objectp<>nil
                 then WSDLLDlg:=Objectp^.ProcessDlg(HWindow,wParam)
                 else WSDLLDlg:=0;
      else
	WSDLLDlg := 0;
      end;
    wm_Destroy: Objectp:=nil;
  else
    WSDLLDlg := 0;
  end;
end;


(* - - - - E X P O R T - - - - *)

procedure DrawObj(BlockP:PBlock; DC: HDC; BMP: TPoint);export;
var
  MemDC: HDC;
  bm: TBitMap;
begin
  MemDC := CreateCompatibleDC(DC);
  SelectObject(MemDC, BitMap[BlockP^.BlockId]);
  GetObject(BitMap[BlockP^.BlockId], SizeOf(bm), @bm);
  BitBlt(DC, BMP.X, BMP.Y, bm.bmWidth, bm.bmHeight, MemDC, 0, 0, SrcCopy);
  DeleteDC(MemDC);
end;

procedure NewObj(var p:PBlock;BlockRef:integer;HWindow:HWnd;SystemP:pSystem);export;
begin
  case BlockRef of
    zReadWave: p:=New(PReadWave,Init(SystemP,BlockRef));
    zWriteWave: p:=New(PWriteWave,Init(SystemP,BlockRef));
    zPlay: p:=New(PPlay,Init(SystemP,BlockRef));
    zFunction: p:=New(PFunction,Init(SystemP,BlockRef));
    zFunctionX: p:=New(PFunctionX,Init(SystemP,BlockRef));
    zFunctionXY: p:=New(PFunctionXY,Init(SystemP,BlockRef));
    zSystem: p:=New(PMacro,Init(SystemP,BlockRef,HWindow));
    zBFilter: p:=New(PBFilter,Init(SystemP,BlockRef));
    zTConv: p:=New(PTConv,Init(SystemP,BlockRef));
    zEco: p:=New(PEco,Init(SystemP,BlockRef));
    zVibrato: p:=New(PVibrato,Init(SystemP,BlockRef));
    zGenerator: p:=New(PGenerator,Init(SystemP,BlockRef));
    zScope1: p:=New(PScope1,Init(SystemP,BlockRef));
    zScopeXY: p:=New(PScopeXY,Init(SystemP,BlockRef));
    zImage: p:=New(PImage,Init(SystemP,BlockRef));
    zMeter: p:=New(PMeter,Init(SystemP,BlockRef));
    zHist: p:=New(PHist,Init(SystemP,BlockRef));
    zSum: p:=New(PSum,Init(SystemP,BlockRef));
    zProd: p:=New(PProd,Init(SystemP,BlockRef));
    zLimiter: p:=New(PLimiter,Init(SystemP,BlockRef));
    zSilencer: p:=New(PSilencer,Init(SystemP,BlockRef));
    zQuantizer: p:=New(PQuantizer,Init(SystemP,BlockRef));
    zDelay: p:=New(PDelay,Init(SystemP,BlockRef));
    zSRLimiter: p:=New(PSRLimiter,Init(SystemP,BlockRef));
    zZeroHold: p:=New(PZeroHold,Init(SystemP,BlockRef));
    zMean: p:=New(PMean,Init(SystemP,BlockRef));
    zDiff: p:=New(PDiff,Init(SystemP,BlockRef));
    zAcc: p:=New(PAcc,Init(SystemP,BlockRef));
    zCompare: p:=New(PCompare,Init(SystemP,BlockRef));
    zSwitch: p:=New(pSwitch,Init(SystemP,BlockRef));
    zRxy: p:=New(pRxy,Init(SystemP,BlockRef));
    zTextOut: p:=New(pTextOut,Init(SystemP,BlockRef));
    zFastMod: p:=New(pFastMod,Init(SystemP,BlockRef));
    zFFTR: p:=New(pFFTR,Init(SystemP,BlockRef));
    zIFFTR: p:=New(pIFFTR,Init(SystemP,BlockRef));
    zMediaSeq: p:=New(pMediaSeq,Init(SystemP,BlockRef));
    zRecord: p:=New(pRecord,Init(SystemP,BlockRef));
    else p:=New(PBlock,Init(SystemP,0));
    end; (* of case *)
end;

procedure NewFromStr(var p:PBlock;var st:string;j:integer;SystemP:pSystem);export;
var sub:string;
    BlockRef:integer;
begin
  GetString(st,sub,j);inc(j);

  BlockRef:=1;
  while (BlockRef <= zLast)and (sub <> Names[BlockRef])
  do inc(BlockRef);
  NewObj(p,BlockRef,0,SystemP);
  if j <= length(st)
  then sub:=copy(st,j,length(st)-j+1)
  else sub:='';
  p^.Store(sub);
end;

procedure DisposeObj(var p:PBlock);export;
begin
  Dispose(p,Done);
end;

function GetNBlocks:integer;export;
begin
  GetNBlocks:=zLast;
end;

function GetBitMap(n:integer):HBitMap;export;
begin
  GetBitMap:=bitMap[n]
end;


procedure Obj2Str(p:PBlock;var Dest:string);export;
begin
  p^.Retrieve(Dest);
end;

procedure Capability(p:PBlock;var Attr:TAttrDev;var IOClass:TAIOClass);export;
begin
p^.Capability(Attr,IOClass);
end;

function DialogObj(HWindow:HWnd;pqwe:PBlock):integer;export;
begin
  DialogObj:=DialogBoxParam(HInstance, DlgNames[pqwe^.BlockID], HWindow, @WSDLLDlg, longint(pqwe));
end;

function CheckObj(pqwe:pBlock;var prop:AIOprop):TResult;export;
var  ErrStr:array[0..127]of char;
(* i valori restituiti sono quelli di <StartAnalysis>

   CheckObj:verifica la correttezza delle informazioni
            memorizzate e la capacita' di supportare
            quanto richiesto
*)
begin
  if pqwe^.StoreParam(0,pqwe^.param,ErrStr)
  then CheckObj:=pqwe^.Check(prop)
  else CheckObj:=8;
end;

function StartAnalysis(pqwe:PBlock;var prop:AIOprop;bufsize:longint;HWindow:HWnd):TResult;export;
var  ErrStr:array[0..127]of char;
(* Start:   verifica che le informazioni memorizzate siano
            corrette, alloca i buffer necessari e azzera le
            variabili interne*)
(* <bufsize> = 0 significa che l'analisi e' del tipo <one-shot>,
   in questo caso l'oggetto deve allocare tutta la memoria necessaria
   all'elaborazione.
(* result = 0 : ok
          = 1 : something has not been defined (e.g.:filename='')
          = 2 : wrong format (e.g. corrupted file )
          = 3 : unsupported format (e.g. 16-bit audio on 8-bit board)
          = 4 : unable to seize buffers/resources
          = 5 : connected terminals are incompatible (fsample/ioattr)
          = 6 : macro internal error
          = 7 : buffer size is incompatible with object
          = 8 : parameter value not supported (e.g. negative timebase)
*)
begin
  if pqwe^.StoreParam(0,pqwe^.param,ErrStr)
  then StartAnalysis:=pqwe^.Start(prop,bufsize,HWindow)
  else StartAnalysis:=8;
end;

procedure StopAnalysis(pqwe:PBlock);export;
begin
  pqwe^.Stop;
end;

function Analysis(pqwe:PBlock;var iop:aiobuf):integer;export;
(* Il risultato di Analysis puo' essere:
   0: nessun problema, l'oggetto e' pronto a elaborare nuovi dati
   1: l'oggetto ha terminato di elaborare/generare dati
*)
begin
  Analysis:=pqwe^.Transfer(iop);
end;

function WSDLLVersion:word;export;
begin
  WSDLLVersion:=$0500; (*  0x0y  *)
end;

procedure GetBufSize(pqwe:PBlock;var bufsize:longint);export;
(* NOTES:
   -  bufsize = 0 <-> no condition on value of bufsize
   -  return value must be greater or equal to given <bufsize>
*)
begin
  pqwe^.GetBufSize(bufsize);
end;


exports
  NewObj       index 1,
  DisposeObj   index 2,
  Capability   index 3,
  GetNBlocks   index 5,
  GetBitMap    index 6,
  Obj2Str      index 7,
  NewFromStr   index 8,
  DialogObj    index 9,
  StartAnalysis index 10,
  StopAnalysis index 11,
  Analysis     index 12,
  WSDLLVersion      index 13,
  CheckObj     index 14,
  GetBufSize   index 15,
  DrawObj      index 4;

(* - - - - TMacro - - - - *)

procedure TMacro.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  if pSys <> nil
  then for i:=1 to MaxTerminal
       do IOClass[i]:=pSys^.TypeIO[i]
  else for i:=1 to MaxTerminal
       do IOClass[i]:=zNone;
end;


function TMacro.Check(var prop:AIOprop):integer;
var result,i:integer;
    scan:pObj;

begin
  if pSys<>nil
  then if LoadResult = 0
       then begin
            scan:=startp;
            result:=0;
            if scan<>nil
            then begin
                 result:=CheckSys(scan,prop);
                 for i:=1 to MaxTerminal
                 do if (pSys^.back[i].obj<>nil)and(pSys^.typeIO[i]and zOutput<>0)
                    then with pSys^.back[i]
                         do prop[i]:=obj^.ioprop[terminal];
                end;
            Check:=result;
            end
       else Check:=LoadResult
  else Check:=1
end;

function TMacro.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
     function xStart(scan:pObj):integer;
     var result,i,j:integer;
         stop:pObj;
     begin
       result:=0;
       if scan<>nil
       then begin
            result:=StartSys(scan,prop,bufsize,HWindow);
            if result = 0
            then for i:=1 to MaxTerminal
                 do if (pSys^.back[i].obj<>nil)and(pSys^.typeIO[i]and zOutput<>0)
                    then with pSys^.back[i]
                         do prop[i]:=obj^.ioprop[terminal];
       end;
       xStart:=result;
     end;
begin
  if pSys<>nil
  then if LoadResult = 0
       then begin
            Start:=xStart(startp);
            end
       else Start:=LoadResult
  else Start:=1
end;

function TMacro.Transfer(var iop:aiobuf):integer;
var scan:pObj;
    i:integer;
    endanalysis:boolean;
begin
   endanalysis:=false;
   scan:=startp;
   while scan <> nil
   do begin
        for i:=1 to MaxTerminal
        do with scan^.backward[i]
           do if obj<>nil
              then scan^.iobuf[i]:=obj^.iobuf[terminal]
              else if terminal <> 0
                   then scan^.iobuf[i]:=iop[terminal];
        if Analysis(scan^.pqwe,scan^.iobuf) <> 0
        then endanalysis:=true;
        for i:=1 to MaxTerminal
        do if (pSys^.back[i].obj<>nil)and(pSys^.typeIO[i]and zOutput<>0)
           then with pSys^.back[i]
                do iop[i]:=obj^.iobuf[terminal];
        scan:=scan^.next;
        end;
   if endanalysis
   then Transfer:=1
   else Transfer:=0;
end;

procedure TMacro.Stop;
var scan:pObj;
begin
  scan:=startp;
  while (scan<>nil)
  do begin
     StopAnalysis(scan^.pqwe);
     scan:=scan^.next;
     end;
end;

destructor TMacro.Done;
begin
  TBlock.Done;
  if pSys <> nil
  then pSys^.Done;
end;

constructor TMacro.Init(SystemP:pSystem;Num:integer;HWindow:HWnd);
var i:integer;
begin
  TBlock.Init(SystemP,Num);
  StrCopy(fn,'');
  LoadResult:=6;
  pSys:=nil;
  Param:='';
  if HWindow <> 0
  then DialogBoxParam(HInstance, 'FileName', HWindow, @WSDLLDlg, longint(@Self));
end;

function TMacro.ReadSystem(tfn:TFilename):boolean;
var
  i,checksys:integer;
  tSys:PSystem;
  result:boolean;
begin
  New(tSys,Init);
  result:=tSys^.ReadSystem(tfn);
  ReadSystem:=false;
  if result
  then begin
       checksys:=tSys^.CheckSystem(startp);
       if pSys <> nil
       then begin (* CHECK MACRO COMPATIBILITY *)
            for i:=1 to MaxTerminal
            do if (tSys^.TypeIO[i]=0)<>(pSys^.TypeIO[i]=0)
               then result:=false;
            if result
            then begin
                 pSys^.Done;
                 pSys:=tSys;
                 end
            else begin
                 MessageBeep(MB_ICONASTERISK);
                 tSys^.Done;
                 exit;
                 end;
            end
       else pSys:=tSys;
       ReadSystem:=true;
       if Checksys = 0
       then LoadResult:=0
       else LoadResult:=6;
       end
  else begin
       tSys^.Done; (* Basta questo ? AP2: Side Effects ? *)
       MessageBeep(MB_ICONASTERISK);
       end;

end;

function tMacro.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j,i:integer;
    more:boolean;
    tClass:TIOClass;
    tempfn:TFileName;
begin
(*  TBlock.Store(st,j);*)
  StoreParam:=false;
  StrCopy(ErrString,'Invalid or incompatible macro file');
  j:=1;
  GetString(st,sub,j);inc(j);
  if (length(sub) = 0)
  then exit;
  if PSys <> nil (* 5555 *)
  then for i:=1 to PSys^.LastVar
       do begin
          if not GetRValue(PS,st,j,PSys^.MacroVar[i].value)then exit;inc(j);
          end;
  if (StrPas(fn) <> sub) (*??????*)
  then begin
       StrPCopy(tempfn,sub);
       if ReadSystem(tempfn)
       then fn:=tempfn
       else exit;
       end;
  StoreParam:=true;
end;

procedure TMacro.SetDlg(HWindow:HWnd);
var  i,j:integer;
     testo:array[0..31]of char;

   procedure SetDlgItem(index,item:integer);
   var  testo:array[0..127]of char;
   begin (* 5555 *)
     StrPCopy(testo,PSys^.MacroVar[index].name);
     SetDlgItemText(HWindow, item, StrCat(testo,':'));
     GetPString(param,testo,j);inc(j);
(*     Str(PSys^.MacroVar[index].value:12:4,testo);*)
     SetDlgItemText(HWindow,item + 1,testo);
   end;

begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow, 104, testo);
  if PSys <> nil
  then for i:=1 to PSys^.LastVar
       do SetDlgItem(i,104 + i*2);
end;

procedure TMacro.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
     i:integer;
begin
  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=StrPas(testo);
  if PSys <> nil (* 5555 *)
  then for i:=1 to PSys^.LastVar
       do begin
          GetDlgItemText(HWindow, 105 + i*2, testo, sizeof(testo));
          st:=st+';'+StrPas(testo);
          end;
end;

function TMacro.ProcessDlg(HWindow:HWnd;wParam:word):integer;
var
  Filter      : array [0..31] of Char;
  tempfn:TFilename;
begin
  if (wParam=104)and(Loadresult <> 0) (*5555*)
  then begin
       FillChar(Filter, SizeOf(Filter), #0);  { Set up for double null at end }
       StrCopy(Filter, 'Systems');
       StrCopy(@Filter[StrLen(Filter)+1], '*.sym');
       GetDlgItemText(HWindow, 104, tempfn, sizeof(tempfn));
       if FileOpen(HWindow,tempfn,Filter,true)
       then SetDlgItemText(HWindow, 104, tempfn);
       end;
  ProcessDlg:=0;
end;


(* - - - - TRecord - - - - *)

procedure TRecord.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[8]:=zOutput;
end;

function TRecord.Check(var prop:AIOprop):integer;
begin
  prop[8].fsample:=fsample;
  prop[8].attr:=zByte or zSimple or zSampled;
  Check:=0;
end;

function TRecord.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
    ErrMsg:array[0..255]of char;
    Dummy:TOFStruct;
begin
  result:=Check(prop);
  if result <> 0
  then begin
       start:=result;
       exit;
       end;
  if bufsize > 65535
  then begin
       start:=4;
       exit;
       end;
  ownsize:=bufsize;
  ParentWnd:=HWindow;
  MemHandle:=0;
  GetTempFileName(GetTempDrive('C'),'LC',0,TempFile);
  Result:=RecordWave(ParentWnd,TempFile,fsample);
  if Result <> 0
  then begin
         mciGetErrorString(Result, ErrMsg, SizeOf(ErrMsg));
         MessageBox(ParentWnd, ErrMsg, 'Record Wave', mb_OK);
         start:=3; (*????*)
         exit;
       end;

  result:=OpenWave(f,TempFile,fsample,slength);
  if result = 0
  then begin
       prop[8].fsample:=fsample;
       prop[8].attr:=zByte or zSimple or zSampled;
       residual:=slength;
       if bufsize = 0
       then ownsize:=slength
       else ownsize:=bufsize;
       MemHandle:=GlobalAlloc(GHnd,ownsize);
       if MemHandle = 0
       then begin
            start:=4;
            _lclose(f);
            OpenFile(TempFile,Dummy,OF_DELETE);
            exit;
            end;
       MemPtr:=GlobalLock(MemHandle);
       end
  else begin
       _lclose(f);
       OpenFile(TempFile,Dummy,OF_DELETE);
       end;
  Start:=result;
end;

function TRecord.Transfer(var iop:aiobuf):integer;
begin
  with iop[8]
  do begin
     if ownsize < residual
     then begin
          _LongRead(f,MemPtr,ownsize);
          size:=ownsize;
          dec(residual,ownsize);
          Transfer:=0;
          end
     else if residual<> 0
          then begin
               _LongRead(f,MemPtr,residual);
               size:=residual;
               residual:=0;
               Transfer:=1;
               end
          else begin
               size:=0;
               Transfer:=1;
               end;
     buf:=MemPtr;
     end;
end;

procedure TRecord.Stop;
var Dummy:TOFStruct;
begin
if MemHandle <> 0
then begin
     GlobalUnLock(MemHandle);
     GlobalFree(MemHandle);
     end;
_lclose(f);
OpenFile(TempFile,Dummy,OF_DELETE);
end;

constructor TRecord.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
(*  fsample:=11025;
  mode:=0; * endless *) 
  Param:='11025;0';
end;

procedure TRecord.SetDlg(HWindow:HWnd); { AP13 }
var  testo:array[0..31]of char;
     j,_mode,code:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,106,testo);
  GetPString(param,testo,j);inc(j);
  val(testo,_mode,code);
  SendDlgItemMessage(HWindow, 107+_mode, bm_SetCheck, 1, 0);
end;

procedure TRecord.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 106, testo, sizeof(testo));
  st:=StrPas(testo);
  if SendDlgItemMessage(HWindow, 107, bm_GetCheck, 0, 0) = 1
  then st:=st+';0'
  else st:=st+';0'; (*??????*)
end;

function TRecord.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
    _fsample:longint;_mode,l:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not GetLValue(PS,st,j,_fsample)then exit;inc(j);
  if not GetIValue(PS,st,j,_mode)then exit;inc(j);
  if (_fsample <= 0)
  then begin
       StrCopy(ErrString,'<fsample> must a positive integer');
       exit;
       end;
  fsample:=_fsample;
  (*mode:=_mode*);
  StoreParam:=true;
end;


(* - - - - TSwitch - - - - *)
const zGE0=1;zG0=2;zE0=3;

constructor TSwitch.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
(*control:=zGE0;   control >= 0 *)
  Param:='1';
end;

procedure TSwitch.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[1]:=zInput;
  IOClass[3]:=zInput;
  IOClass[5]:=zInput;
  IOClass[8]:=zOutput;
end;

function TSwitch.Check(var prop:AIOprop):integer;
var i:integer;
begin
  SwitchType:=prop[1].attr and zMaskType;
  if (prop[1].attr <> prop[3].attr)and
     (prop[5].attr and (zMaskComplex ) <> zSimple)
     then begin
          Check:=5;
          exit;
          end;
  Check:=0;
  prop[8]:=prop[1];
end;

function TSwitch.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
  result:=Check(prop);
  if result = 0
  then begin
(*AP6*)MemHandle:=AllocArray(bufsize,SwitchType);
       if MemHandle = 0
       then begin
            start:=4;
            exit;
            end;
       MemPtr:=GlobalLock(MemHandle);
       controltype:=prop[5].attr and zMaskType;
       end;
  Start:=result;
end;

function TSwitch.Transfer(var iop:aiobuf):integer;
  function shortest(var iop:aiobuf):longint;
  var size:longint;
      i:integer;
  begin
    Transfer:=0;
    size:=iop[1].size;
    if iop[3].size < size
    then size:=iop[3].size;
    shortest:=size;
  end;

  function state(i:longint):boolean;
  begin
    case Control of
      zGE0:case ControlType of
             zByte:state:=ByteArray(iop[5].buf^)[i]>=128;
             zInteger:state:=(IntegerArray(iop[5].buf^)[i])>=0;
             zReal:state:=(RealArray(iop[5].buf^)[i])>=0;
             end; (* of case *)
      zG0:case ControlType of
             zByte:state:=ByteArray(iop[5].buf^)[i]>128;
             zInteger:state:=(IntegerArray(iop[5].buf^)[i])>0;
             zReal:state:=(RealArray(iop[5].buf^)[i])>0;
             end; (* of case *)
      zE0:case ControlType of
             zByte:state:=ByteArray(iop[5].buf^)[i]=128;
             zInteger:state:=(IntegerArray(iop[5].buf^)[i])=0;
             zReal:state:=(RealArray(iop[5].buf^)[i])=0;
             end; (* of case *)
      end; (* of case *)
  end;

  procedure xxx_byte(len:longint);
  var i:longint;
  begin
     for i:=0 to len-1
     do if state(i)
        then ByteArray(MemPtr^)[i]:=ByteArray(iop[1].buf^)[i]
        else ByteArray(MemPtr^)[i]:=ByteArray(iop[3].buf^)[i];
  end;

  procedure xxx_integer(len:longint);
  var i:longint;
  begin
     for i:=0 to len-1
     do if state(i)
        then IntegerArray(MemPtr^)[i]:=IntegerArray(iop[1].buf^)[i]
        else IntegerArray(MemPtr^)[i]:=IntegerArray(iop[3].buf^)[i];
  end;

  procedure xxx_real(len:longint);
  var i:longint;
  begin
     for i:=0 to len-1
     do if state(i)
        then RealArray(MemPtr^)[i]:=RealArray(iop[1].buf^)[i]
        else RealArray(MemPtr^)[i]:=RealArray(iop[3].buf^)[i];
  end;

begin
  Transfer:=0;
  iop[8].buf:=MemPtr;
  iop[8].size:=shortest(iop);
  case SwitchType of
    zByte:xxx_byte(Shortest(iop));
    zInteger:xxx_integer(Shortest(iop));
    zReal:xxx_real(Shortest(iop));
    end; (* of case *)
end;


procedure TSwitch.Stop;
begin
if MemHandle <> 0
then begin
     GlobalUnLock(MemHandle);
     GlobalFree(MemHandle);
     end;
end;

procedure TSwitch.SetDlg(HWindow:HWnd); 
var ID:integer;
    testo:array[0..31]of char;
    j:integer;
    _control,code:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  val(testo,_control,code);
  case _control of
    zGE0:ID:=104;
    zG0:ID:=105;
    zE0:ID:=106;
  end; (* of case *)
  SendDlgItemMessage(HWindow, ID, bm_SetCheck, 1, 0);
end;

procedure TSwitch.GetDlg(HWindow:HWnd;var st:string);
var _Control:integer;
begin
  if SendDlgItemMessage(HWindow, 104, bm_GetCheck, 0, 0) = 1
  then _Control:=zGE0
  else if SendDlgItemMessage(HWindow, 105, bm_GetCheck, 0, 0) = 1
       then _Control:=zG0
       else _Control:=zE0;
  Str(_Control,st);
end;

function TSwitch.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not GetIValue(PS,st,j,control)then exit;inc(j);
  StoreParam:=true;
end;

(* - - - - TRxy - - - - *)

constructor TRxy.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
(*  M:=16;
  cumulative:=0;   * not cumulative * 
  biased:=0;       * not biased     *)
  Param:='0;0;16';
end;

procedure TRxy.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[1]:=zInput;
  IOClass[3]:=zInput;
  IOClass[8]:=zOutput;
end;

function TRxy.Check(var prop:AIOprop):integer;
var i:integer;
begin
  if (prop[1].attr <> prop[3].attr)
     then begin
          Check:=5;
          exit;
          end;
  Check:=0;
  InputType:=prop[1].attr and zMaskType;
  if InputType = zByte
  then RxyType:=zInteger
  else RxyType:=InputType;
  prop[8].attr:=prop[1].attr and not zMaskType or Rxytype;
  prop[8].fsample:=prop[1].fsample;
end;

function TRxy.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
  result:=Check(prop);
  if result = 0
  then begin
       if bufsize < M (* bug was 'bufsize<=M' *)
       then begin
            start:=7;
            exit;
            end;
       InputType:=prop[1].attr and zMaskType;
       if InputType = zByte
       then RxyType:=zInteger
       else RxyType:=InputType;
(*AP6*)MemHandle:=AllocArray(bufsize,RxyType);
       if MemHandle = 0
       then begin
            start:=4;
            exit;
            end;
       MemPtr:=GlobalLock(MemHandle);
       ownsize:=bufsize;
       OldN:=0;
       end;
  Start:=result;
end;

function TRxy.Transfer(var iop:aiobuf):integer;
  function shortest(var iop:aiobuf):longint;
  var size:longint;
      i:integer;
  begin
    size:=iop[1].size;
    if iop[3].size < size
    then size:=iop[3].size;
    shortest:=size;
  end;

  procedure xxx_byte(len:longint);
  var k,z:longint;
      i:integer;
      FullSize:longint;
  begin
     FullSize:=OldN+OwnSize;
     for i:=0 to M-1
     do begin
        if (cumulative = 0)or(OldN = 0)
        then z:=0
        else z:=(IntegerArray(MemPtr^)[i]) * OldN;
        for k:=0 to len-1-i
        do z:=z+(ByteArray(iop[1].buf^)[k]-128)*
                (ByteArray(iop[3].buf^)[k+i]-128);
        if biased <> 0
        then IntegerArray(MemPtr^)[i]:=z div FullSize
        else IntegerArray(MemPtr^)[i]:=z div (FullSize-i);
        end;
     if cumulative <> 0
     then OldN:=FullSize;
  end;

  procedure xxx_integer(len:longint);
  var k,z:longint;
      i:integer;
      FullSize:longint;
  begin
     Transfer:=0;
     FullSize:=OldN+OwnSize;
     for i:=0 to M-1
     do begin
        if (cumulative = 0)or(OldN = 0)
        then z:=0
        else z:=(IntegerArray(MemPtr^)[i]) * OldN;
        for k:=0 to len-1-i
        do z:=z+IntegerArray(iop[1].buf^)[k]*(IntegerArray(iop[3].buf^)[k+i]);
        if biased <> 0
        then IntegerArray(MemPtr^)[i]:=z div FullSize
        else IntegerArray(MemPtr^)[i]:=z div (FullSize-i);
        end;
     if cumulative <> 0
     then OldN:=FullSize;
  end;

  procedure xxx_real(len:longint);
  var k:longint;
      z:real;
      i:integer;
      FullSize:longint;
  begin
     FullSize:=OldN+OwnSize;
     for i:=0 to M-1
     do begin
        if (cumulative = 0)or(OldN = 0)
        then z:=0
        else z:=(RealArray(MemPtr^)[i]) * OldN;
        for k:=0 to len-1-i
        do z:=z+RealArray(iop[1].buf^)[k]*(RealArray(iop[3].buf^)[k+i]);
        if biased <> 0
        then RealArray(MemPtr^)[i]:=z / FullSize
        else RealArray(MemPtr^)[i]:=z / (FullSize-i);
        end;
     if cumulative <> 0
     then OldN:=FullSize;
  end;

begin
  Transfer:=0;
  iop[8].buf:=MemPtr;
  iop[8].size:=M;
  case InputType of
    zByte:xxx_byte(Shortest(iop));
    zInteger:xxx_integer(Shortest(iop));
    zReal:xxx_real(Shortest(iop));
    end; (* of case *)
end;


procedure TRxy.Stop;
begin
if MemHandle <> 0
then begin
     GlobalUnLock(MemHandle);
     GlobalFree(MemHandle);
     end;
end;

procedure TRxy.SetDlg(HWindow:HWnd); { AP13 }
var  testo:array[0..31]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SendDlgItemMessage(HWindow, 104, bm_SetCheck, ord(testo[0])-ord('0'), 0);
  GetPString(param,testo,j);inc(j);
  SendDlgItemMessage(HWindow, 105, bm_SetCheck, ord(testo[0])-ord('0'), 0);
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,106,testo);
end;

procedure TRxy.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  Str(SendDlgItemMessage(HWindow, 104, bm_GetCheck, 0, 0),st);
  Str(SendDlgItemMessage(HWindow, 105, bm_GetCheck, 0, 0),testo);
  st:=st+';'+StrPas(testo);
  GetDlgItemText(HWindow, 106, testo, sizeof(testo));
  st:=st+';'+StrPas(testo);
end;

function TRxy.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
    _M,_biased,_cumulative:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not GetIValue(PS,st,j,_cumulative)then exit;inc(j);
  if not GetIValue(PS,st,j,_biased)then exit;inc(j);
  if not GetIValue(PS,st,j,_M)then exit;inc(j);
  if (_M > 1023)or (_M <= 0)
  then begin
       StrCopy(ErrString,'<M> must an integer in [1..1023]');
       exit;
       end;
  M:=_M;
  biased:=_biased;
  cumulative:=_cumulative;
  StoreParam:=true;
end;


(* - - - - TTextOut - - - - *)

const zOnlyX=0;zPascal=1; (* NON CAMBIARE QUESTI VALORI !*)

function TTextOut.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
    _control:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  GetString(st,sub,j);inc(j);
  if not GetIValue(PS,st,j,_control)then exit;inc(j);
  if length(sub) = 0   (*??????????????*)
  then begin
         StrCopy(ErrString,'Invalid file');
         exit;
       end;
  StrPCopy(fn,sub);
  control:=_control;
  StoreParam:=true;
end;

procedure TTextOut.SetDlg(HWindow:HWnd);
var  testo:array[0..31]of char;
     j:integer;
     _control,code:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow, 104, testo);
  GetPString(param,testo,j);inc(j);
  val(testo,_control,code);
  SendDlgItemMessage(HWindow, 106+_control, bm_SetCheck, 1, 0);
end;

function TTextOut.ProcessDlg(HWindow:HWnd;wParam:word):integer;
var  Filter      : array [0..31] of Char;
     tempfn:TFilename;
begin
  if wParam=104
  then begin
       FillChar(Filter, SizeOf(Filter), #0);  { Set up for double null at end }
       StrCopy(Filter, 'Text Files');
       StrCopy(@Filter[StrLen(Filter)+1], '*.txt');
       GetDlgItemText(HWindow, 104, tempfn, sizeof(tempfn));
       if FileOpen(HWindow,tempfn,Filter,false)
       then SetDlgItemText(HWindow, 104, tempfn);
       end;
  ProcessDlg:=0;
end;

procedure TTextOut.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
     _Control:integer;
begin
  GetDlgItemText(HWindow, 104, testo, sizeof(testo));
  st:=StrPas(testo);
  if SendDlgItemMessage(HWindow, 106, bm_GetCheck, 0, 0) = 1
  then _Control:=zOnlyX
  else if SendDlgItemMessage(HWindow, 107, bm_GetCheck, 0, 0) = 1
       then _Control:=zPascal
       else _Control:=zPascal; (*???*)
  Str(_Control,testo);
  st:=st+';'+StrPas(testo);
end;

constructor TTextOut.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  fn[0]:=#0;
  Param:=';0';
end;

procedure TTextOut.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[2]:=zInput;
end;

function TTextOut.Check(var prop:AIOprop):integer;
begin
  OwnType:=prop[2].attr and zMaskType;
  if strlen(fn)=0
  then Check:=1
  else if prop[2].attr and zSimple = zSimple
       then Check:=0
       else Check:=5

end;

function TTextOut.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
    fsample:longint;
    y,m,d,dow:word;
begin
  fsample:=prop[2].fsample;
  result:=Check(prop);
  if result <> 0
  then begin
       start:=result;
       exit;
       end;
  if bufsize > 65535
  then begin
       start:=4;
       exit;
       end;
  ownsize:=bufsize;
  Assign(f,fn);
  {$I-}
  rewrite(f);
  {$I+}
  if IOResult<>0
  then begin
       start:=4;
       exit;
       end;
  GetDate(y,m,d,dow);
  writeln(f,'/* Created by WinSound, ',d:2,'-',m:2,'-',y,' */');
  write(f,'fs=',fsample);
  case OwnType of
    zByte:write(f,';type=byte');
    zInteger:write(f,';type=integer');
    zReal:write(f,';type=real');
    end; (* of case *)
  writeln(f,';bs=',bufsize);
  start:=0;
  slength:=0;
end;

function TTextOut.Transfer(var iop:aiobuf):integer;
var i:longint;
begin
  Transfer:=0;
  with iop[2]
  do begin
     case OwnType of
       zByte:begin
             for i:=0 to size-1
             do case control of
                  zOnlyX:writeln(f,ByteArray(buf^)[i]-128);
                  zPascal:writeln(f,'x[',i+slength,']:=',ByteArray(buf^)[i]-128,';');
                  end; (* of case *)
             end;
       zInteger:begin
             for i:=0 to size-1
             do case control of
                  zOnlyX:writeln(f,IntegerArray(buf^)[i]);
                  zPascal:writeln(f,'x[',i+slength,']:=',IntegerArray(buf^)[i],';');
                  end; (* of case *)
             end;
       zReal:begin
             for i:=0 to size-1
             do case control of
                  zOnlyX:writeln(f,RealArray(buf^)[i]);
                  zPascal:writeln(f,'x[',i+slength,']:=',RealArray(buf^)[i],';');
                  end; (* of case *)
             end;
       end; (* of case *)
     inc(slength,ownsize);  (* absolute position *)
     end;
end;

procedure TTextOut.Stop;
begin
  Close(f);
end;

(* - - - - TFastMod - - - - *)

procedure TFastMod.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[1]:=zInput;
  IOClass[3]:=zInput;
  IOClass[8]:=zOutput;
end;

function TFastMod.Check(var prop:AIOprop):integer;
var i:integer;
begin
  if (prop[1].attr <> prop[3].attr)
     then begin
          Check:=5;
          exit;
          end;
  InputType:=prop[1].attr and zMaskType;
  if InputType <> zInteger
  then begin
       Check:=5;
       exit;
       end;
  Check:=0;
  prop[8].attr:=prop[1].attr;
  prop[8].fsample:=prop[1].fsample;
end;

function TFastMod.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
  result:=Check(prop);
  if result = 0
  then begin
(*AP6*)MemHandle:=AllocArray(bufsize,InputType);
       if MemHandle = 0
       then begin
            start:=4;
            exit;
            end;
       MemPtr:=GlobalLock(MemHandle);
       end;
  Start:=result;
end;

function TFastMod.Transfer(var iop:aiobuf):integer;
  function shortest(var iop:aiobuf):longint;
  var size:longint;
      i:integer;
  begin
    size:=iop[1].size;
    if iop[3].size < size
    then size:=iop[3].size;
    shortest:=size;
  end;

  function radius(xx,yy:integer):integer;
  var x,y,t:longint;
      r:longint;

  begin
  x:=abs(xx);
  y:=abs(yy);
  if y>=x
  then begin
       t:=x;x:=y;y:=t;
       end;
  if x<>0
  then begin
         t:=x+y shr 1;
         y:=abs(y-x shr 1);
         x:=t+y shr 2;
         y:=abs(y-t shr 2);
         r:=x+y shr 3+abs(y-x shr 3)shr 4;
         radius:=r * 1761 shr 11;
       end
  else radius:=0;
  end;

  procedure xxx_integer(len:longint);
  var i:longint;
  begin
     for i:=0 to len-1
     do begin
        IntegerArray(MemPtr^)[i]:=radius(IntegerArray(iop[1].buf^)[i],
                          IntegerArray(iop[3].buf^)[i]);
        end;

  end;

begin
  Transfer:=0;
  iop[8].buf:=MemPtr;
  iop[8].size:=shortest(iop);
  case InputType of
    zInteger:xxx_integer(Shortest(iop));
    end; (* of case *)
end;


procedure TFastMod.Stop;
begin
if MemHandle <> 0
then begin
     GlobalUnLock(MemHandle);
     GlobalFree(MemHandle);
     end;
end;

(* - - - - TFFTR - - - - *)

type pRealArray=^RealArray;

procedure fft(re,im:pRealArray;m:integer);
 var i,j,k,l,p:word;tx,ty,t1x,t1y,rotx,roty:real;tin:real;
 begin
  i:=0;
  for k:=1 to m-1
  do begin
     l:=m;
     repeat l:=l div 2 until i+l<=m-1;
     i:=i mod l+l;
     if i>k then begin
                 tx:=re^[k];
                 ty:=im^[k];
                 re^[k]:=re^[i];
                 im^[k]:=im^[i];
                 re^[i]:=tx;
                 im^[i]:=ty;
                 end
     end;
   l:=1;
   repeat
   p:=l*2;
   rotx:=cos(pi/l);tx:=1;
   roty:=sin(pi/l);ty:=0;
   for k:=0 to l-1
   do begin
      j:=k;
      while j<m
      do begin
         t1x:=tx*re^[j+l]-ty*im^[j+l];
         t1y:=tx*im^[j+l]+ty*re^[j+l];
         re^[j+l]:=re^[j]-t1x;
         im^[j+l]:=im^[j]-t1y;
         re^[j]:=re^[j]+t1x;
         im^[j]:=im^[j]+t1y;
         j:=j+p
         end;
       tin:=tx*rotx-ty*roty;
       ty:=tx*roty+ty*rotx;
       tx:=tin;
      end;
  l:=p;
  until l>=m;
 end;

constructor TFFTR.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
(*  M:=1024;
  window:=0;   * no window *) 
  Param:='1024;0';
end;

procedure TFFTR.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[2]:=zInput;
  IOClass[7]:=zOutput;
  IOClass[9]:=zOutput;
end;

function TFFTR.Check(var prop:AIOprop):integer;
var i:integer;
begin
  InputType:=prop[2].attr and zMaskType;
  if InputType <> zReal
     then begin
          Check:=5;
          exit;
          end;
  Check:=0;
  prop[7].attr:=prop[2].attr;
  prop[7].fsample:=prop[2].fsample;
  prop[9].attr:=prop[2].attr;
  prop[9].fsample:=prop[2].fsample;
end;

function TFFTR.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;

  procedure prepare_window;
  var i:longint;
      a,t:real;
  begin
    a:=2 / (bufsize - 1);
    case window of
    1: (* TRIANGULAR *)
       for i:=0 to bufsize div 2 - 1
       do begin
          RealArray(winPtr^)[i]:=a * i;
          RealArray(winPtr^)[bufsize - 1 - i]:=a * i;
          end;
    2: (* HANNING *)
       for i:=0 to bufsize div 2 - 1
       do begin
          t:=0.5*(1-cos(a*Pi*i));
          RealArray(winPtr^)[i]:=t;
          RealArray(winPtr^)[bufsize - 1 - i]:=t;
          end;
    3: (* HAMMING *)
       for i:=0 to bufsize div 2 - 1
       do begin
          t:=0.54-0.46*cos(a*Pi*i);
          RealArray(winPtr^)[i]:=t;
          RealArray(winPtr^)[bufsize - 1 - i]:=t;
          end;
    end; (* of case *)
  end;

begin
  result:=Check(prop);
  if result = 0
  then begin
       if bufsize mod M <> 0
       then begin
            start:=7;
            exit;
            end;
(*AP6*)reH:=AllocArray(bufsize,InputType);
       if reH = 0
       then begin
            start:=4;
            exit;
            end;
(*AP6*)imH:=AllocArray(bufsize,InputType);
       if imH = 0
       then begin
            GlobalFree(reH);
            start:=4;
            exit;
            end;
       if window <> 0
       then begin
     (*AP6*)winH:=AllocArray(bufsize,InputType);
            if winH = 0
            then begin
                 GlobalFree(reH);
                 GlobalFree(imH);
                 start:=4;
                 exit;
                 end;
            winPtr:=GlobalLock(winH);
            prepare_window;
            end;
       rePtr:=GlobalLock(reH);
       imPtr:=GlobalLock(imH);
       ownsize:=bufsize;
       end;
  Start:=result;
end;

function TFFTR.Transfer(var iop:aiobuf):integer;
var run:integer;
    first:longint;

  procedure prepare_fft_real;
  var i,last:longint;
  begin
     last := longint(run) * longint(M) - 1;
     if last > iop[2].size - 1
     then begin
          for i := iop[2].size to last
          do begin
             RealArray(rePtr^)[i]:=0;  (* PAD WITH ZERO *)
             RealArray(imPtr^)[i]:=0;
             end;
          last := iop[2].size - 1;
          end;
     if window <> 0 (* window is used ? *)
     then for i:= 0 to last
          do begin
             RealArray(rePtr^)[i] := RealArray(iop[2].buf^)[i]*RealArray(winPtr^)[i];
             RealArray(imPtr^)[i] := 0;
             end
     else for i:= 0 to last
          do begin
             RealArray(rePtr^)[i] := RealArray(iop[2].buf^)[i];
             RealArray(imPtr^)[i] := 0;
             end;
  end;

begin
  Transfer:=0;
  run:=(iop[2].size+M-1) div M;first:=0;
  prepare_fft_real; (* COPY AND PAD WITH ZERO *)
  while run <> 0
  do begin
     fft(@RealArray(rePtr^)[first],@RealArray(imPtr^)[first],M);
     dec(run);inc(first,M);
     end;
  iop[9].buf:=rePtr;
  iop[9].size:=first;
  iop[7].buf:=imPtr;
  iop[7].size:=first;
end;


procedure TFFTR.Stop;
begin
if reH <> 0
then begin
     GlobalUnLock(reH);
     GlobalFree(reH);
     end;
if imH <> 0
then begin
     GlobalUnLock(imH);
     GlobalFree(imH);
     end;
if window <> 0
then begin
     GlobalUnLock(winH);
     GlobalFree(winH);
     end;
end;

procedure TFFTR.SetDlg(HWindow:HWnd); { AP13 }
var  testo:array[0..31]of char;
     j,_window,code:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,106,testo);
  GetPString(param,testo,j);inc(j);
  val(testo,_window,code);
  SendDlgItemMessage(HWindow, 107+_window, bm_SetCheck, 1, 0);
end;

procedure TFFTR.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 106, testo, sizeof(testo));
  st:=StrPas(testo);
  if SendDlgItemMessage(HWindow, 107, bm_GetCheck, 0, 0) = 1
  then st:=st+';0'
  else if SendDlgItemMessage(HWindow, 108, bm_GetCheck, 0, 0) = 1
       then st:=st+';1'
       else if SendDlgItemMessage(HWindow, 109, bm_GetCheck, 0, 0) = 1
            then st:=st+';2'
            else st:=st+';3';
end;

function TFFTR.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
    _M,_window,l:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not GetIValue(PS,st,j,_M)then exit;inc(j);
  if not GetIValue(PS,st,j,_window)then exit;inc(j);
  l:=_M;
  if (_M <= 0)
  then begin
       StrCopy(ErrString,'<M> must a positive integer');
       exit;
       end;
  while not odd(l)
  do l:=l div 2;
  if l <> 1
  then begin
       StrCopy(ErrString,'<M> should be a power of 2');
       exit;
       end;
  M:=_M;
  window:=_window;
  StoreParam:=true;
end;

(* - - - - TIFFTR - - - - *)


constructor TIFFTR.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
(*  M:=1024;*)
  Param:='1024';
end;

procedure TIFFTR.Capability(var Attr:TAttrDev;var IOClass:TAIOClass);
var i:integer;
begin
  TBlock.Capability(Attr,IOClass);
  IOClass[1]:=zInput;
  IOClass[3]:=zInput;
  IOClass[8]:=zOutput;
end;

function TIFFTR.Check(var prop:AIOprop):integer;
var i:integer;
begin
  if (prop[1].attr <> prop[3].attr)
     then begin
          Check:=5;
          exit;
          end;
  InputType:=prop[1].attr and zMaskType;
  if (InputType <> zReal)
     then begin
          Check:=5;
          exit;
          end;
  Check:=0;
  prop[8].attr:=prop[1].attr;
  prop[8].fsample:=prop[1].fsample;
end;

function TIFFTR.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
var result:integer;
begin
  result:=Check(prop);
  if result = 0
  then begin
       if bufsize mod M <> 0
       then begin
            start:=7;
            exit;
            end;
(*AP6*)reH:=AllocArray(bufsize,InputType);
       if reH = 0
       then begin
            start:=4;
            exit;
            end;
(*AP6*)imH:=AllocArray(bufsize,InputType);
       if imH = 0
       then begin
            GlobalFree(reH);
            start:=4;
            exit;
            end;
       rePtr:=GlobalLock(reH);
       imPtr:=GlobalLock(imH);
       ownsize:=bufsize;
       end;
  Start:=result;
end;

function TIFFTR.Transfer(var iop:aiobuf):integer;
var run:integer;
    first:longint;

  procedure prepare_ifft_real;
  var i,last:longint;
  begin
     last := longint(run) * longint(M) - 1;
     if last > iop[1].size - 1
     then begin
          for i := iop[1].size to last
          do begin
             RealArray(rePtr^)[i]:=0;  (* PAD WITH ZERO *)
             RealArray(imPtr^)[i]:=0;
             end;
          last := iop[1].size - 1;
          end;
     for i:= 0 to last
     do begin
        RealArray(rePtr^)[i] := RealArray(iop[1].buf^)[i];
        RealArray(imPtr^)[i] := -RealArray(iop[3].buf^)[i];
        end;
  end;

  procedure end_ifft_real;
  var i:longint;
  begin
     for i:= 0 to first-1
     do begin
        RealArray(rePtr^)[i] := RealArray(rePtr^)[i]/M;
(* la seguente linea e' stata soppressa perche' il risultato dovrebbe essere
   reale *)
(*        RealArray(imPtr^)[i] := -RealArray(imPtr^)[i]/M;*)
        end;
  end;

begin
  Transfer:=0;
  run:=(iop[1].size+M-1) div M;first:=0;
  prepare_ifft_real; (* COPY AND PAD WITH ZERO *)
  while run <> 0
  do begin
     fft(@RealArray(rePtr^)[first],@RealArray(imPtr^)[first],M);
     dec(run);inc(first,M);
     end;
  end_ifft_real;
  iop[8].buf:=rePtr;
  iop[8].size:=first;
end;


procedure TIFFTR.Stop;
begin
if reH <> 0
then begin
     GlobalUnLock(reH);
     GlobalFree(reH);
     end;
if imH <> 0
then begin
     GlobalUnLock(imH);
     GlobalFree(imH);
     end;
end;

procedure TIFFTR.SetDlg(HWindow:HWnd); { AP13 }
var  testo:array[0..31]of char;
     j,_window,code:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,106,testo);
end;

procedure TIFFTR.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 106, testo, sizeof(testo));
  st:=StrPas(testo);
end;

function TIFFTR.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
    _M,l:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not GetIValue(PS,st,j,_M)then exit;inc(j);
  if (_M <= 0)
  then begin
       StrCopy(ErrString,'<M> must a positive integer');
       exit;
       end;
  l:=_M;
  while not odd(l)
  do l:=l div 2;
  if l <> 1
  then begin
       StrCopy(ErrString,'<M> should be a power of 2');
       exit;
       end;
  M:=_M;
  StoreParam:=true;
end;


(* - - - - TMediaSeq - - - - *)

constructor TMediaSeq.Init(SystemP:pSystem;Num:integer);
begin
  TBlock.Init(SystemP,Num);
  nsub:=1;
  Param:='1';
end;

function TMediaSeq.Start(var prop:AIOprop;bufsize:longint;HWindow:HWnd):integer;
begin
  if bufsize mod nsub <> 0
  then begin
       start:=7;
       exit;
       end;
  M:=bufsize div nsub;
  Start:=t1In1Out.Start(prop,M,HWindow);
end;

function TMediaSeq.Transfer(var iop:aiobuf):integer;
var i,k:longint;
    accb:integer;acci:longint;

begin
  Transfer:=0;
  iop[8].buf:=MemPtr;
  iop[8].size:=M;
  case OwnType of
    zByte: begin
           for i:=0 to M-1
           do begin
              accb:=0;
              for k:=0 to nsub-1
              do accb:=accb+(ByteArray(iop[2].buf^)[i+k*M]-128);
              ByteArray(iop[8].buf^)[i]:=accb div nsub + 128;
              end;
           end;
    zInteger: begin
           for i:=0 to M-1
           do begin
              acci:=0;
              for k:=0 to nsub-1
              do acci:=acci+(IntegerArray(iop[2].buf^)[i+k*M]-128);
              IntegerArray(iop[8].buf^)[i]:=acci div nsub + 128;
              end;
           end;
    zReal: begin
           for i:=0 to M-1
           do RealArray(iop[8].buf^)[i]:=0;
           for i:=0 to iop[2].size-1
           do RealArray(iop[8].buf^)[i Mod M]:=
              RealArray(iop[8].buf^)[i Mod M]+RealArray(iop[2].buf^)[i];
           for i:=0 to M-1
           do RealArray(iop[8].buf^)[i]:=RealArray(iop[8].buf^)[i] / nsub;
           end;
    end; (* of case *)
end;


procedure TMediaSeq.SetDlg(HWindow:HWnd);
var  testo:array[0..127]of char;
     j:integer;
begin
  TBlock.SetDlg(HWindow);
  j:=1;
  GetPString(param,testo,j);inc(j);
  SetDlgItemText(HWindow,106,testo);
end;

procedure TMediaSeq.GetDlg(HWindow:HWnd;var st:string);
var  testo:array[0..127]of char;
begin
  GetDlgItemText(HWindow, 106, testo, sizeof(testo));
  st:=StrPas(testo);
end;

function TMediaSeq.StoreParam(HWindow:HWnd;var st:string;ErrString:PChar):boolean;
var sub:string;j:integer;
    code:integer;
    _nsub:integer;
begin
  StoreParam:=false;StrCopy(ErrString,BadFormat);
  j:=1;
  if not GetIValue(PS,st,j,_nsub)then exit;inc(j);
  if (_nsub <= 0)
  then begin
       StrCopy(ErrString,'<number of subsequences> must a positive integer');
       exit;
       end;
  nsub:=_nsub;
  StoreParam:=true;
end;


var i:integer;
begin
  ExitProc:=@DLLExit;
  for i:=0 to zLast
  do BitMap[i] := LoadBitMap(hInstance, BMPNames[i]);
  SetUpPalette;
end.
